#include "ttl_calc.h"
#include "util.h"

/* build_DNS_reply builds a payload for the UDP packet
 * so that it apears to be a DNS reply for www.hotmail.com
 */

void TTL_Mod::build_DNS_reply (u_char *packet)
{
        struct DNSHEADER *dnsh;
        u_char *localpacket = packet;
#if BYTE_ORDER == LITTLE_ENDIAN
        u_short one = htons(1);
#else
        u_short one = 1;
#endif
        dnsh = (struct DNSHEADER *) localpacket;
        dnsh->id = getrandom(U_SHORTMAX);
        dnsh->qr = 1;
        dnsh->opcode = 0;
        dnsh->aa = 0;
        dnsh->tc = 0;
        dnsh->rd = 1;
        dnsh->ra = 1;
        dnsh->cd = 1;
        dnsh->ad = 0;
        dnsh->rcode = 0;
        dnsh->qdcount = htons(1);
        dnsh->ancount = htons(1);
        dnsh->nscount = 0; 
        dnsh->arcount = 0;
        localpacket+=12;
        memcpy (localpacket, "\003www\007hotmail\003com",17);
        localpacket+=17;
        memcpy(localpacket, &one, 2);
        localpacket+=2;
        memcpy(localpacket, &one, 2);
        localpacket+=2;
        memcpy (localpacket, "\003www\007hotmail\003com",17);
        localpacket+=17;
        memcpy(localpacket, &one, 2);
        localpacket+=2;
        memcpy(localpacket, &one, 2);
        localpacket+=2;
        one=0xffff;
        memcpy(localpacket, &one, 4);
        localpacket+=4;
        one=4;
        memcpy(localpacket, &one, 2);
        localpacket+=2;
        inet_aton("64.4.53.7",&dnsh->replydata);


} /* END OF BUILD_DNS_REPLY */
