/* $Id: xprobe_module_param.h,v 1.1 2002/08/08 11:25:56 fygrave Exp $ */
/*
** Copyright (C) 2001 Fyodor Yarochkin <fygrave@tigerteam.net>,
**                    Ofir Arkin       <ofir@sys-security.com>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** All material for nonprofit, educational use only.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef XPROBE_MODULE_PARAM_H
#define XPROBE_MODULE_PARAM_H

#include "xprobe.h"
#include "usi++/usi++.h"
#include "target.h"
#include "os_matrix.h"
#include <string>



#define XPROBE_MODULE_PARAM_BOOL    1      /* y/n */
#define XPROBE_MODULE_PARAM_ZNZ     2      /* zero, not zero -- !0, 0 */
#define XPROBE_MODULE_PARAM_INT     3      /* int - 1234 */
#define XPROBE_MODULE_PARAM_RANGE   4      /* range - <1, >2, 20-40 */

typedef struct xprobe_module_param_val {
    int high;
    int low;
} xprobe_module_param_t;



class Xprobe_Module_Param {
    private:
        int id;
        int type;
        map <int, xprobe_module_param_t> osid_sig;
        int sig_insert(int os_id, xprobe_module_param_t p);
    public:
        Xprobe_Module_Param(int t) { type = t; }
        virtual ~Xprobe_Module_Param(void) { return; }
        virtual int check_param(ICMP *ip_pkt, OS_Matrix *os) =0;    
        int parse_param(int os_id, const char *param);
        int add_param(int param, OS_Matrix *os);
        void set_id(int i) { id = i; }
        int get_id(void) { return id; }
};


#endif /* XPROBE_MODULE_PARAM */
